<?php
/*
 * WPGear. 
 * Org. Departments
 * functions.php
 */

	/* Get Options
	----------------------------------------------------------------- */
	function OrgDepartments_Get_Options () {
		$OrgDepartments_Options = get_option("orgdepartments_options", array(
			'adminonly' => 1,
			'sortby' => 'name',
			)
		);

		return $OrgDepartments_Options;
	}
	
	/* Get Departments
	----------------------------------------------------------------- */
	function OrgDepartments_Get_Departments ($user_id) {
		global $OrgDepartments_Options;
		
		$taxonomy = 'departments';

		$args = array (
			'taxonomy' => $taxonomy,
			'page' => 1,
			'number' => 0,
			'search' => '',
			'hide_empty' => 0,
			'offset' => 0,
			'orderby' => $OrgDepartments_Options['sortby'],
		);		
		$terms = get_terms ($args);
		
		$Terms_Hierarchy = OrgDepartments_Get_Departments_Hierarchy_Structure ($taxonomy);
		
		$start = 0;
		$end = wp_count_terms($taxonomy);
		$count = 0;
		$parent = 0;
		$level = 0;
		
		$terms = OrgDepartments_Get_Departments_Tree ($taxonomy, $terms, $Terms_Hierarchy, $start, $end, $count, $parent, $level);	

		if (empty($terms)) {
			$output = 'No Departments ...';
		} else {
			$output = '';
			
			$ListCategory_Levels = array();			
			
			foreach ($terms as $term) {
				$term_id 	= $term -> term_id;
				$term_count = $term -> count;
				$Level 		= $term -> level;				
				
				$Department_CSS_Class = get_term_meta ($term_id, 'department_css_class', true);				
				
				if ($user_id) {							
					// Редактирование Пользователя				
					?>
					<label for="departments-<?php echo esc_attr($term->slug); ?>" class="<?php echo esc_attr($Department_CSS_Class); ?>" style="margin-left: <?php echo esc_attr((24*$Level)); ?>px;">
						<input type="checkbox" name="departments[]" id="departments-<?php echo esc_attr($term->slug); ?>" value="<?php echo esc_attr($term->slug); ?>" <?php checked(true, is_object_in_term($user_id, $taxonomy, $term->slug)); ?>><?php echo esc_attr($term->name ." [$term_count]");?>
					</label>
					<br/>
					<?php							
				} else {
					// Регистрация Нового Пользователя
					?>
					<label for="departments-<?php echo esc_attr($term->slug); ?>" class="<?php echo esc_attr($Department_CSS_Class); ?>" style="margin-left: <?php echo esc_attr((24*$Level)); ?>px;">
						<input type="checkbox" name="departments[]" id="departments-<?php echo esc_attr($term->slug); ?>" value="<?php echo esc_attr($term->slug);?>"><?php echo esc_attr($term->name ." [$term_count]");?>
					</label>
					<br/>
					<?php					
				}			
			}
		}
	}	
		
	/* Get Departments Hierarchy Structure
	----------------------------------------------------------------- */	
	function OrgDepartments_Get_Departments_Hierarchy_Structure ($taxonomy) {
		$children = array();
		
		$args = array (
			'taxonomy'               	=> $taxonomy,
			'get'                    	=> 'all',
			'fields'                 	=> 'id=>parent',
			'orderby'					=> 'none',	
		);

		$terms = get_terms ($args);			
		
		foreach ($terms as $term_id => $parent) {
			if ($parent > 0) {
				$children[$parent][] = $term_id;
			}
		}
		
		return $children;
	}
	
	/* Get Departments Tree whith Levels
	----------------------------------------------------------------- */		
	function OrgDepartments_Get_Departments_Tree ($taxonomy, $terms, &$children, $start, $end, &$count, $parent = 0, $level = 0, &$result = array()) {	
		foreach ( $terms as $key => $term ) {
			if ($count >= $end) {
				break;
			}

			if ($term->parent != $parent){
				continue;
			}

			if ($count == $start && $term->parent > 0) {
				$my_parents = $parent_ids = array();
				$p = $term->parent;

				while ($p) {
					$my_parent = get_term ($p, $taxonomy);
					$my_parents[] = $my_parent;
					$p = $my_parent->parent;
					
					if (in_array ($p, $parent_ids))
						break;
					$parent_ids[] = $p;
				}
				unset ($parent_ids);

				$num_parents = count ($my_parents);
				while ($my_parent = array_pop ($my_parents)) {
					$my_parent->level = $level;
					$result[] = $my_parent;
				}
			}

			if ($count >= $start) {
				$term->level = $level;
				$result[] = $term;
			}

			$count = $count + 1;
			
			unset ($terms[$key]);

			if (isset ($children[$term->term_id])) {
				OrgDepartments_Get_Departments_Tree ($taxonomy, $terms, $children, $start, $end, $count, $term->term_id, $level + 1, $result);
			}
		}
		
		return $result;
	}	